package fr.inra.pappso.class_pep;

import java.io.Serializable;

public class seq_prot implements Serializable {
	private static final long serialVersionUID = 13114L;

	// attributs
	private String accession;

	private String description;
	
	private int peptides;
	
	private String number;

	protected String sequence;
	
	// constructeurs
	public seq_prot() {
		this.accession = null;
		this.description = null;
		this.sequence = "";
		this.setNumber("-");
		this.setPeptides(0);
	}

	public void set_sequence(String S) {
		this.sequence = wash_sequence(S);
	}

	public void set_description(String D) {
		D = D.replaceAll("<", "_");
		D = D.replaceAll(">", "_");
		String[] acc = D.split(" ");
		this.accession = acc[0];
		this.description = "";
		for (int i = 1; i< acc.length ; i++)
			this.description += acc[i]+" ";
	}

	public String get_accession() {
		return (accession);
	}

	public String get_description() {
		return (description);
	}

	public String get_sequence() {
		return (sequence);
	}

	public String get_fasta() {
		String fasta = ">" + accession + " " + description + System.getProperty("line.separator");
		for (int i = 0; i < sequence.length(); i += 60) {
			if (i + 60 < sequence.length())
				fasta += sequence.substring(i, i + 60) + System.getProperty("line.separator");
			else {
				fasta += sequence.substring(i, sequence.length()) + System.getProperty("line.separator");
			}
		}
		return (fasta);
	}

	private String wash_sequence(String seq) {
		seq = seq.toUpperCase();
		seq = seq.replaceAll("[^GASPVTLINDKQEMHFRCYWX-]", "");
		return (seq);

	}

	public boolean have_a_sequence() {
		if (this.sequence.equals(""))
			return (false);
		else
			return (true);
	}

	public void setPeptides(int peptides) {
		this.peptides = peptides;
	}

	public int getPeptides() {
		return peptides;
	}

	public void setNumber(String number) {
		this.number = number;
	}

	public String getNumber() {
		return number;
	}
	
	public boolean is_same_protein(String descrip) {
		String[] acces = descrip.split(" ");
		if (this.accession.equalsIgnoreCase(acces[0]))
			return true;
		else
			return false;
	}
	
}
