package fr.inra.pappso.gui;

import java.awt.GridLayout;
import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.AbstractButton;
import javax.swing.JDialog;
import javax.swing.JButton;
import javax.swing.JFileChooser;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.JFrame;

import fr.inra.pappso.pep_exception.PepException;
import fr.inra.pappso.pep_exception.StopException;
import fr.inra.pappso.pipeline.fasts_conf;
import fr.inra.pappso.pipeline.pepnovo_conf;
import fr.inra.pappso.sax_parse.Serialising;

import java.io.File;

public class configuration_windows extends JDialog implements ActionListener {

	private static final long serialVersionUID = 1L;

	private pepnovo_conf conf_pep;

	private fasts_conf conf_fast;

	private JTextField thread = new JTextField();

	private JTextField textFieldScore = new JTextField();

	private JLabel labelScore = new JLabel("", JLabel.CENTER);

	private JTextField select_file = new JTextField();

	private JLabel texte_select = new JLabel("", JLabel.CENTER);

	private JFileChooser fileChooser;

	private my_file_filter FT;

	private boolean stop;

	private boolean pep_conf;

	private JTextField textFieldPepnovoModel = new JTextField();
	private JLabel labelPepnovoModel = new JLabel("", JLabel.CENTER);

	public configuration_windows(JFrame owner, boolean modal, pepnovo_conf X) {
		super(owner, modal);
		this.conf_pep = X;
		this.pep_conf = true;
		// initialise la fenetre
		init();
		// ajoute les données
		add_data_pepnovo();
		// regle et affiche la fenetre
		setSize(400, 250);
		setLocationRelativeTo(owner);
		setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);
		setVisible(true);
	}

	public configuration_windows(JFrame owner, boolean modal, fasts_conf X) {
		super(owner, modal);
		this.conf_fast = X;
		this.pep_conf = false;
		// initialise la fenetre
		init();
		// ajoute les données
		add_data_fasts();
		// regle et affiche la fenetre
		setSize(400, 250);
		setLocationRelativeTo(owner);
		setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);
		setVisible(true);
	}

	private void init() {
		// creation de la boite de Dialogue
		stop = false;
		this.setTitle("Configuration of the searching parameters");
		this.setLayout(new BorderLayout());
		JPanel pane1 = new JPanel();
		JPanel pane2 = new JPanel();
		JPanel pane3 = new JPanel();

		pane1.setLayout(new GridLayout(6, 1));
		pane1.add(new JLabel("Select the number of CPUs, you want to use : ",
				JLabel.CENTER), 0);
		pane1.add(thread, 1);
		pane1.add(labelScore, 2);
		pane1.add(textFieldScore, 3);
		pane1.add(this.labelPepnovoModel, 4);
		pane1.add(this.textFieldPepnovoModel, 5);
		pane1.add(texte_select, 6);

		pane2.setLayout(new GridLayout(1, 2));
		pane2.add(select_file);
		JButton select = new JButton("Select");
		select.addActionListener(this);
		pane2.add(select);
		pane1.add(pane2);

		this.add(pane1, BorderLayout.CENTER);

		JButton ok = new JButton("Start");
		ok.addActionListener(this);
		pane3.add(ok);
		JButton ok2 = new JButton("Stop");
		ok2.addActionListener(this);
		pane3.add(ok2);
		this.add(pane3, BorderLayout.SOUTH);

	}

	private void add_data_pepnovo() {
		labelScore.setText("Quality score : from 0 to 1 (0.01)");
		this.labelPepnovoModel.setText("Model name (CID_IT_TRYP by default)");
		texte_select
				.setText("The X!Tandem results exported with XTandem Parser");
		thread.setText("" + conf_pep.getThread());
		textFieldScore.setText("" + conf_pep.getSeuil());

		this.textFieldPepnovoModel.setText(conf_pep.getPepnovoModel());
		// conf_pep.setXml_dir();
		if (conf_pep.getXmlFile() == null)
			select_file.setText("No select");
		else
			select_file.setText(conf_pep.getXmlFile().getAbsolutePath());
	}

	private void add_data_fasts() {
		labelScore.setText("PepNovo score : from 50 to 100 (70)");
		texte_select.setText("Path to the contaminants database");
		thread.setText("" + conf_fast.getThread());
		textFieldScore.setText("" + conf_fast.getPepnovo_score());
		select_file.setText(conf_fast.getDatabase_conta().getAbsolutePath());
	}

	private File get_file_fasta() throws StopException {
		fileChooser = new JFileChooser();
		fileChooser.setDialogTitle("Select the contaminants database");
		fileChooser.setFileSelectionMode(JFileChooser.OPEN_DIALOG);
		fileChooser.setFileSelectionMode(JFileChooser.FILES_ONLY);
		fileChooser.setMultiSelectionEnabled(false);
		fileChooser.setCurrentDirectory(new File(""));
		FT = new my_file_filter(new String[] { "fasta" },
				"FASTA file (*.fasta)");
		fileChooser.addChoosableFileFilter(FT);
		// fileChooser.setFileFilter(new FileFilter(".xml"));
		int returnValue = fileChooser.showOpenDialog(this);
		if (returnValue == JFileChooser.CANCEL_OPTION)
			throw new StopException("No fasta selected");
		File files = fileChooser.getSelectedFile();
		return (files);
	}

	private File get_dir_xml() throws StopException {
		fileChooser = new JFileChooser();
		fileChooser
				.setDialogTitle("Select the file containing X!Tandem results");
		fileChooser.setFileSelectionMode(JFileChooser.OPEN_DIALOG);
		fileChooser.setFileSelectionMode(JFileChooser.FILES_ONLY);
		fileChooser.setMultiSelectionEnabled(false);
		fileChooser.setCurrentDirectory(new File(""));
		fileChooser.setFileFilter(new my_file_filter(new String[] { "xml" },
				"pepnovo.xml file (*.xml)"));
		int returnValue = fileChooser.showOpenDialog(this);
		if (returnValue == JFileChooser.CANCEL_OPTION)
			throw new StopException("No directory selected");
		File files = fileChooser.getSelectedFile();
		return (files);
	}

	public boolean isStop() {
		return stop;
	}

	public void setStop(boolean stop) {
		this.stop = stop;
	}

	private void modified_pep_conf() throws PepException {
		float fl;
		int it1;
		try {
			it1 = Integer.parseInt(thread.getText());
		} catch (Exception e) {
			throw new PepException("The number of threads must be a number");
		}
		if (it1 < 1)
			throw new PepException("The number of threads must be > 1");

		try {
			fl = Float.valueOf(textFieldScore.getText()).floatValue();
		} catch (Exception e) {
			throw new PepException("The quality score must be a number");
		}
		if (fl > 1)
			throw new PepException("The quality score must be < 1");
		if (fl < 0)
			throw new PepException("The quality score must be > 0");

		conf_pep.setThread(it1);
		conf_pep.setSeuil(fl);
		conf_pep.setPepnovoModel(textFieldPepnovoModel.getText().trim());
	}

	private void modified_fasts_conf() throws PepException {
		int fl;
		int it1;
		try {
			it1 = Integer.parseInt(thread.getText());
		} catch (Exception e) {
			throw new PepException("The number of threads must be a number");
		}
		if (it1 < 1)
			throw new PepException("The number of threads must be > 1");

		try {
			fl = Integer.parseInt(textFieldScore.getText());
		} catch (Exception e) {
			throw new PepException("The PepNovo score must be a number");
		}
		if (fl < 0)
			throw new PepException("The PepNovo score must be > 0");

		conf_fast.setThread(it1);
		conf_fast.setPepnovo_score(fl);
	}

	private void ok_clic() {
		try {
			if (pep_conf) {
				this.modified_pep_conf();
				new Serialising().serialise_pep_conf(conf_pep);
			} else {
				this.modified_fasts_conf();
				new Serialising().serialise_fasts_conf(conf_fast);
			}
			dispose();
		} catch (Exception e) {
			JOptionPane.showMessageDialog(this,
					"Problems saving the configuration :\n" + e, "Error",
					JOptionPane.ERROR_MESSAGE);
		}
	}

	private void select_directori_clic() {
		try {
			File files = this.get_dir_xml();
			this.conf_pep.setXmlFile(files);

			JOptionPane.showMessageDialog(this, "File selected with success",
					"Message", JOptionPane.INFORMATION_MESSAGE);
		} catch (Exception e) {
			JOptionPane.showMessageDialog(this,
					"Problems during file selection :\n" + e, "Error",
					JOptionPane.ERROR_MESSAGE);
		} finally {
			select_file.setText(conf_pep.getXmlFile().getName());
		}
	}

	private void select_database_clic() {
		try {
			File files = this.get_file_fasta();
			this.conf_fast.setDatabase_conta(files);

			JOptionPane.showMessageDialog(this,
					"Database selected with success", "Message",
					JOptionPane.INFORMATION_MESSAGE);
		} catch (Exception e) {
			JOptionPane.showMessageDialog(this,
					"Problems during database selection :\n" + e, "Error",
					JOptionPane.ERROR_MESSAGE);
		} finally {
			select_file
					.setText(conf_fast.getDatabase_conta().getAbsolutePath());
		}
	}

	private void stop_clic() {
		// TODO Auto-generated method stub
		this.stop = true;
		dispose();

	}

	public void actionPerformed(ActionEvent evt) {
		String composant = evt.getActionCommand();
		if (composant.equalsIgnoreCase("Start"))
			ok_clic();
		if (composant.equalsIgnoreCase("Stop"))
			stop_clic();
		if (composant.equalsIgnoreCase("Select")) {
			if (pep_conf)
				select_directori_clic();
			else
				select_database_clic();
		}
	}

	public pepnovo_conf getConf_pep() {
		return conf_pep;
	}

	public void setConf_pep(pepnovo_conf conf_pep) {
		this.conf_pep = conf_pep;
	}

	public fasts_conf getConf_fast() {
		return conf_fast;
	}

	public void setConf_fast(fasts_conf conf_fast) {
		this.conf_fast = conf_fast;
	};

}
