package fr.inra.pappso.pipeline;

import java.io.File;
import java.util.Vector;

import fr.inra.pappso.class_pep.Ms_run;
import fr.inra.pappso.class_pep.Pep_result;
import fr.inra.pappso.pep_exception.StopException;
import fr.inra.pappso.sax_parse.Serialising;


public class export_pepnovo_sequence extends process {

	public export_pepnovo_sequence() {
		super();
		this.setType_of_process("pepnovo_export");
	}

	public void run() {
		try {
			this.processing();
		} catch (StopException e) {
		} catch (Exception e) {
			e.printStackTrace();
			StackTraceElement[] f = e.getStackTrace();
			this.setError(e.getMessage() + "\nat : " + f[0].toString());
			// print error on screen!!!
			// stopping(""+e);
			this.set_view("Error:\n" + this.getError());
			this.setStop(true);
		}
	}

	private void processing() throws Exception {
		// Ecrire le process et penser à relever des StopException
		this.set_view("Initialising");
		this.get_out().open(this.getSave().getAbsolutePath());
		this.get_out().write(
				"File" + "\t" + "Scan" + "\t" + "Sequence" + "\t"
						+ "Sequence score" + "\t" + "Filter score" + "\n");
		for (int i = 0; i < this.get_files().length; i++) {
			File f = this.get_files()[i];
			this.set_view("Export file:\n" + f.getName());
			Ms_run run = new Serialising().unserialise_msrun(f
					.getAbsolutePath());
			Vector<Pep_result> peps = run.get_Pepnovo_result();
			for (int j = 0; j < peps.size(); j++) {
				Pep_result pep = peps.elementAt(j);
				String S = f.getName() + "\t" + pep.get_Scan() + "\t"
						+ pep.get_Sequence() + "\t" + pep.get_PnvScr() + "\t"
						+ pep.get_RnkScr() + "\n";
				this.get_out().write(S);
			}
			if (this.isStop()) {
				this.get_out().close();
				throw new StopException("Analysis stopped");
			}
		}
		this.get_out().close();
	}

	public String toString() {
		return ("Export Pepnovo Sequences");
	}

}
