package fr.inra.pappso.class_pep;

import java.io.Serializable;
import java.util.Vector;

public class Pep_result implements Serializable {

	private static final long serialVersionUID = 4L;

	private String scan;

	private float RnkScr;

	private float PnvScr;

	private float N_Gap;

	private float C_Gap;

	private float Mh_pepnovo;

	private int charge;

	private String Sequence;

	private boolean use_by_fasts;

	public Pep_result() {
		se_tRnkScr(0);
		set_PnvScr(0);
		use_by_fasts = false;

	}
	
	public String toString(){
		return(this.scan+"-"+this.get_Sequence_with_ncter());
	}
	
	public void set_Scan(String sp) {
		this.scan = sp;
	}

	public String get_Scan() {
		return scan;
	}

	public boolean is_use_by_fasts() {
		return use_by_fasts;
	}

	public void set_use_by_fasts(boolean b) {
		this.use_by_fasts = b;
	}

	public void se_tRnkScr(float rnkScr) {
		RnkScr = rnkScr;
	}

	public float get_RnkScr() {
		return RnkScr;
	}

	public void set_PnvScr(float pnvScr) {
		PnvScr = pnvScr;
	}

	public float get_PnvScr() {
		return PnvScr;
	}

	public void set_N_Gap(float n_Gap) {
		N_Gap = n_Gap;
	}

	public float ge_tN_Gap() {
		return N_Gap;
	}

	public void set_C_Gap(float c_Gap) {
		C_Gap = c_Gap;
	}

	public float get_C_Gap() {
		return C_Gap;
	}

	public void set_Mh_pepnovo(float mh_pepnovo) {
		Mh_pepnovo = mh_pepnovo;
	}

	public float get_Mh_pepnovo() {
		return Mh_pepnovo;
	}

	public void set_Charge(int charge) {
		this.charge = charge;
	}

	public int get_Charge() {
		return charge;
	}

	public void set_Sequence(String seq) {
		Sequence = seq.replaceAll("M\\+16", "m");
	}

	public String get_Sequence() {
		return (Sequence);
	}

	public String get_Sequence_with_ncter() {
		String seq = Sequence;
		if (this.N_Gap != 0)
			seq = "X" + seq;
		if (this.C_Gap != 0)
			seq = seq + "X";
		return (seq);
	}

	public Vector<modifs> get_modifs() {
		Vector<modifs> mods = new Vector<modifs>();
		String complete_seq = this.get_Sequence_with_ncter();
//		Matcher met_oxy = Pattern.compile(".*(m).*").matcher(complete_seq);
//		// System.out.println("match = "+ met_oxy.groupCount());
//		if (met_oxy.find()) {
//			for (int i = 0; i < met_oxy.groupCount(); i++) {
//				modifs m = new modifs();
//				m.set_AA("M");
//				m.set_modvalue((float) 15.9951);
//				m.set_posi(met_oxy.start(i) + 1);
//				mods.add(m);
//				System.out.println(met_oxy.start(i) + 1);
//			}
//		}
		if (this.N_Gap != 0) {
			modifs m = new modifs();
			m.set_AA("X");
			m.set_modvalue((float)(this.N_Gap));
			m.set_posi(1);
			mods.add(m);
		}
		if (this.C_Gap != 0) {
			modifs m = new modifs();
			m.set_AA("X");
			m.set_modvalue((float)(this.C_Gap-19.01893));
			m.set_posi(complete_seq.length());
			mods.add(m);
		}
		return (mods);
	}

}
