package fr.inra.pappso.gui;

import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.util.Vector;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextPane;
import javax.swing.Timer;

import fr.inra.pappso.pep_exception.PepException;
import fr.inra.pappso.pipeline.fasts_conf;
import fr.inra.pappso.pipeline.fasts_pip;


public class running_fasts extends JDialog {

	/**
	 * 
	 */
	private static final long serialVersionUID = -638460483564860213L;

	private actions_bouton ab;
	
	private JTextPane current_process = new JTextPane();
	
	private JLabel processe_advance = new JLabel();
	
	private JButton Action1;
	
	private fasts_conf conf;
	
	private File[] pepnovo;
	
	private Vector<fasts_pip> process;
	
	private monthread2 t;

	private Timer timer;
	
	public running_fasts (JFrame owner, boolean modal, fasts_conf conf, File[] pepnovo) {
		super(owner, modal);
		this.conf = conf;
		this.pepnovo = pepnovo;
		this.process = new Vector<fasts_pip>();
		// initialise la fenetre 
		init();
		t = new monthread2();
		t.setDaemon(true);
		t.start();
		// regle et affiche la fenetre
		setSize(300, 200);
		setLocationRelativeTo(owner);
		setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);
		setVisible(true);
	}

	private void init() {
		// TODO Auto-generated method stub
		ab = new actions_bouton();
		Action1 = new JButton("Stop");
		Action1.addActionListener(ab);
		
		JPanel panel = new JPanel();
		panel.add(processe_advance);
		panel.add(Action1);
		
		current_process.setText("<p>Initialising</p>");
		current_process.setContentType("text/html");
		current_process.setEditable(false);
		getContentPane().add(panel, BorderLayout.SOUTH);
		getContentPane()
				.add(new JScrollPane(current_process), BorderLayout.CENTER);
		
		timer = new Timer(1000, ab);
		timer.setInitialDelay(0);
		timer.start();
		
	}

	private void stopping() {
		// TODO Auto-generated method stub
		this.stop_process();
		this.dispose();
	}
	
	private void stop_process(){
		timer.stop();
		for (int i = 0; i < process.size(); i++) {
			fasts_pip pipe = process.elementAt(i);
			pipe.stop_process();
		}
		t.set_analysed(this.pepnovo.length);
		this.actualised();
	}
	
	private void actualised(){
		current_process.setText(t.getView());
		processe_advance.setText("Analysis finished : " + t.getanalysed() + "/"
				+ pepnovo.length+" ");
		repaint();
	}

	class actions_bouton implements ActionListener {
		public void actionPerformed(ActionEvent evt) {
			if (evt.getSource() == Action1) {
				String composant = evt.getActionCommand();
				if (composant.equalsIgnoreCase("Stop"))
					stopping();
			} else if (evt.getSource() == timer) {
				actualised();
				if (!t.isAlive())
					stopping();
			}
		}

	};

	class monthread2 extends Thread {

		private String view;

		private int analysed;
		
		public void run() {
			try {
				fasts_pip pipe;
				analysed = 0;
				int index = 0;
				StringBuilder v;
				while (analysed < pepnovo.length) {
					v = new StringBuilder();
					if (process.size() < conf.getThread() & (index<pepnovo.length)) {
						pipe = new fasts_pip();
						pipe.setConf(conf);
						pipe.setPepnovo_seria(pepnovo[index]);
						pipe.start();
						process.add(pipe);
						index++;
					}
					for (int i = 0; i < process.size(); i++) {
						pipe = process.elementAt(i);
						if (!pipe.isAlive()) {
							if (!pipe.getError().equals(""))
								throw new PepException(pipe.getError());
							analysed++;
							process.remove(i);
						}
						v.append("<p>"+pipe.getPepnovo_seria().getName() + "<br />");
						v.append(pipe.getStatus() + "</p>");
					}
					this.set_view(v.toString());
					Thread.currentThread();
					// attendre un peu
					Thread.sleep(500);
				}
			} catch (Exception e) {
				e.printStackTrace();
				// print error on screen!!!				
				//stopping(""+e);
				this.set_view("Error:\n"+e);
				stop_process();
				
			}
		}

		public String getView() {
			return(this.view);
		}
		
		public void set_view(String v){
			this.view =v;
		}
		
		public int getanalysed() {
			return(this.analysed);
		}
		public void set_analysed(int stop){
			this.analysed=stop;
		}
	};
	
}
